{-# LANGUAGE FlexibleContexts      #-}
{-# LANGUAGE MultiParamTypeClasses #-}
module Autosubst.GenCode (generateCode) where

import           Autosubst.Generator
import           Autosubst.GeneratorLean
import           Autosubst.Types
import           Control.Monad.Except
import           Control.Monad.Reader
import           Control.Monad.RWS       hiding ((<>))

import           Autosubst.GenM
import qualified Data.Map                as M
import           Data.Maybe              as Maybe
import           Prelude                 hiding ((<$>))
import           Text.PrettyPrint.Leijen

import           Autosubst.Coq
import           Autosubst.Lean
import           Autosubst.Signature
import           Data.List               as L

-- Embedding in the monadic structure
generateCode :: Prover -> GenM ()
generateCode Coq = do
  spec <- components
  code <- genCode spec
  tell (coqPreamble <$$> empty <$$> vsep (map (\s -> coqShow s <$$> empty) code))
  return ()
generateCode Lean = do
  spec <- components
  code <- genLeanCode spec
  tell (leanPreamble <$$> empty <$$> vsep (map (\s -> leanShow s <$$> empty) code))
    -- <$$> vsep (map (\s -> leanShow s <$$> empty) automation))
  return ()
